/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM calICalendarSearchProvider.idl
 */

#ifndef __gen_calICalendarSearchProvider_h__
#define __gen_calICalendarSearchProvider_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class calIOperation; /* forward declaration */

class calIGenericOperationListener; /* forward declaration */


/* starting interface:    calICalendarSearchProvider */
#define CALICALENDARSEARCHPROVIDER_IID_STR "306da1c9-db54-4ef3-b27e-fea709f638ff"

#define CALICALENDARSEARCHPROVIDER_IID \
  {0x306da1c9, 0xdb54, 0x4ef3, \
    { 0xb2, 0x7e, 0xfe, 0xa7, 0x09, 0xf6, 0x38, 0xff }}

class NS_NO_VTABLE calICalendarSearchProvider : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(CALICALENDARSEARCHPROVIDER_IID)

  /**
     * Specifies whether the search string should exactly match.
     */
  enum { HINT_EXACT_MATCH = 1U };

  /**
     * Searches for calendars matching the specified search string.
     * It's up to the search provider what properties of a calendar
     * it takes into account for the search. The passed hints serve
     * for optimization purposes. Callers need to keep in mind that
     * providers may not be able to implement all of the stated hints
     * passed, thus are required to filter further if necessary.
     * Results are notified to the passed listener interface.
     *
     * @param aString     search string to match
     * @param aHints      search hints
     * @param aMaxResults maximum number of results
     *                    (0 denotes provider specific maximum)
     * @param aListener   called with an array of calICalendar objects
     * @return            optional operation handle to track the operation
     */
  /* calIOperation searchForCalendars (in AUTF8String aString, in unsigned long aHints, in unsigned long aMaxResults, in calIGenericOperationListener aListener); */
  NS_IMETHOD SearchForCalendars(const nsACString & aString, PRUint32 aHints, PRUint32 aMaxResults, calIGenericOperationListener *aListener, calIOperation **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_CALICALENDARSEARCHPROVIDER \
  NS_IMETHOD SearchForCalendars(const nsACString & aString, PRUint32 aHints, PRUint32 aMaxResults, calIGenericOperationListener *aListener, calIOperation **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_CALICALENDARSEARCHPROVIDER(_to) \
  NS_IMETHOD SearchForCalendars(const nsACString & aString, PRUint32 aHints, PRUint32 aMaxResults, calIGenericOperationListener *aListener, calIOperation **_retval) { return _to SearchForCalendars(aString, aHints, aMaxResults, aListener, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_CALICALENDARSEARCHPROVIDER(_to) \
  NS_IMETHOD SearchForCalendars(const nsACString & aString, PRUint32 aHints, PRUint32 aMaxResults, calIGenericOperationListener *aListener, calIOperation **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->SearchForCalendars(aString, aHints, aMaxResults, aListener, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public calICalendarSearchProvider
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_CALICALENDARSEARCHPROVIDER

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, calICalendarSearchProvider)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* calIOperation searchForCalendars (in AUTF8String aString, in unsigned long aHints, in unsigned long aMaxResults, in calIGenericOperationListener aListener); */
NS_IMETHODIMP _MYCLASS_::SearchForCalendars(const nsACString & aString, PRUint32 aHints, PRUint32 aMaxResults, calIGenericOperationListener *aListener, calIOperation **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    calICalendarSearchService */
#define CALICALENDARSEARCHSERVICE_IID_STR "2f2055ca-f558-4dc8-a1d4-11384a00e85c"

#define CALICALENDARSEARCHSERVICE_IID \
  {0x2f2055ca, 0xf558, 0x4dc8, \
    { 0xa1, 0xd4, 0x11, 0x38, 0x4a, 0x00, 0xe8, 0x5c }}

/**
 * This service acts as a central access point for calendar lookup.
 * A search request will be multiplexed to all added search providers.
 * Adding a search provider is transient.
 */
class NS_NO_VTABLE calICalendarSearchService : public calICalendarSearchProvider {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(CALICALENDARSEARCHSERVICE_IID)

  /**
     * Gets the currently registered set of search providers.
     */
  /* void getProviders (out PRUint32 aCount, [array, size_is (aCount), retval] out calICalendarSearchProvider aProviders); */
  NS_IMETHOD GetProviders(PRUint32 *aCount, calICalendarSearchProvider ***aProviders) = 0;

  /**
     * Adds a new search provider.
     */
  /* void addProvider (in calICalendarSearchProvider aProvider); */
  NS_IMETHOD AddProvider(calICalendarSearchProvider *aProvider) = 0;

  /**
     * Removes a search provider.
     */
  /* void removeProvider (in calICalendarSearchProvider aProvider); */
  NS_IMETHOD RemoveProvider(calICalendarSearchProvider *aProvider) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_CALICALENDARSEARCHSERVICE \
  NS_IMETHOD GetProviders(PRUint32 *aCount, calICalendarSearchProvider ***aProviders); \
  NS_IMETHOD AddProvider(calICalendarSearchProvider *aProvider); \
  NS_IMETHOD RemoveProvider(calICalendarSearchProvider *aProvider); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_CALICALENDARSEARCHSERVICE(_to) \
  NS_IMETHOD GetProviders(PRUint32 *aCount, calICalendarSearchProvider ***aProviders) { return _to GetProviders(aCount, aProviders); } \
  NS_IMETHOD AddProvider(calICalendarSearchProvider *aProvider) { return _to AddProvider(aProvider); } \
  NS_IMETHOD RemoveProvider(calICalendarSearchProvider *aProvider) { return _to RemoveProvider(aProvider); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_CALICALENDARSEARCHSERVICE(_to) \
  NS_IMETHOD GetProviders(PRUint32 *aCount, calICalendarSearchProvider ***aProviders) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetProviders(aCount, aProviders); } \
  NS_IMETHOD AddProvider(calICalendarSearchProvider *aProvider) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddProvider(aProvider); } \
  NS_IMETHOD RemoveProvider(calICalendarSearchProvider *aProvider) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveProvider(aProvider); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public calICalendarSearchService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_CALICALENDARSEARCHSERVICE

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, calICalendarSearchService)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void getProviders (out PRUint32 aCount, [array, size_is (aCount), retval] out calICalendarSearchProvider aProviders); */
NS_IMETHODIMP _MYCLASS_::GetProviders(PRUint32 *aCount, calICalendarSearchProvider ***aProviders)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addProvider (in calICalendarSearchProvider aProvider); */
NS_IMETHODIMP _MYCLASS_::AddProvider(calICalendarSearchProvider *aProvider)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeProvider (in calICalendarSearchProvider aProvider); */
NS_IMETHODIMP _MYCLASS_::RemoveProvider(calICalendarSearchProvider *aProvider)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_calICalendarSearchProvider_h__ */
